package com.mh.mme;

import javax.microedition.lcdui.*;

import com.mh.mfw;
import com.mh.playliststore;

/**
 * <p>Title: Mh Media Envirnoment</p>
 *
 * <p>Description: New Mh Media Product</p>
 *
 * <p>Copyright: Mh Copyright (c) 2005-2007</p>
 *
 * <p>Company: Mh Xorp <WAS></p>
 *
 * @author Mihard
 * @version null
 */
public class mm extends List implements CommandListener {
    int bkv;
    public mm(int bv) {
        super(mme.lng.mm, List.IMPLICIT);
        try {
            bkv = bv;
            jbInit();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private void jbInit() throws Exception {
        // Set up this Displayable to listen to command events
        setCommandListener(this);
        // add the Exit command
        append(mme.lng.plls, null);
        append(mme.lng.files, null);
        append(mme.lng.opt, null);
        addCommand(new Command(mme.lng.exit, Command.EXIT, 0));
        if (bkv != 0) {
            addCommand(new Command(mme.lng.back, Command.CANCEL, 1));
        }
    }

    public void commandAction(Command command, Displayable displayable) {

        if (command.getCommandType() == Command.EXIT) {

            mme.quitApp();
        } else if (command.getCommandType() == Command.CANCEL) {
            switch (bkv) {
            case 0:
                mme.quitApp();
                break;
            case 1:
                mme.ShowIt(mme.aupl);
                break;
            case 2:
                mme.pause();
                mme.ShowIt(mme.vdpl);
                break;
            case 3:
                mme.ShowIt(mme.mhtr);
                break;
            }
        } else {
            switch (getSelectedIndex()) {
            case 0:
                plsm t = new plsm();
                mme.ShowIt(t);
                break;
            case 1:
                index tt = new index();
                mme.ShowIt(tt);
                break;

            case 2:
                opt ttt = new opt(bkv);
                mme.ShowIt(ttt);
                break;
            }

        }
    }

}


class plsm extends List implements CommandListener {
    public plsm() {
        super(mme.lng.plls, List.IMPLICIT);
        try {
            jbInit();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private void jbInit() throws Exception {
        // Set up this Displayable to listen to command events
        setCommandListener(this);
        // add the Exit command
        append(mme.lng.aud, null);
        append(mme.lng.vid, null);
        addCommand(new Command(mme.lng.back, Command.BACK, 0));
    }

    public void commandAction(Command command, Displayable displayable) {

        if (command.getCommandType() == Command.BACK) {
            // stop the MIDlet
            mm t = new mm(0);
            mme.ShowIt(t);
        } else {
            switch (getSelectedIndex()) {
            case 0:
                pllsm t = new pllsm(playliststore.AUDIO_TYPE, mfw.AUDIO_FORMATS,
                                    0);
                mme.ShowIt(t);
                break;
            case 1:
                pllsm tt = new pllsm(playliststore.VIDEO_TYPE,
                                     mfw.VIDEO_FORMATS, 0);
                mme.ShowIt(tt);
                break;
            case 2:
                pllsm ttt = new pllsm(playliststore.LIB_TYPE, mfw.TEXT_FORMATS,
                                      0);
                mme.ShowIt(ttt);
                break;
            }

        }
    }

}


class pllsm extends List implements CommandListener {
    private static int type, type1, bkv;
    public pllsm(int typ, int typ1, int bv) {
        super(mme.lng.plls, List.IMPLICIT);
        try {
            bkv = bv;
            type = typ;
            type1 = typ1;
            jbInit(typ);
        } catch (Exception e) {
            e.printStackTrace();
        }

    }

    private void jbInit(int type) throws Exception {
        // Set up this Displayable to listen to command events
        setCommandListener(this);
        // add the Exit command
        append("<" + mme.lng.newpl + ">", null);
        String[] plls = mme.pllss.getPlaylists(type);
        System.out.println("appending");
        try {
            for (int i = 0; i < plls.length; i++) {

                append(plls[i], null);

            }
        } catch (Exception ex) {
            append("null", null);
        }

        addCommand(new Command(mme.lng.back, Command.BACK, 0));
        addCommand(new Command(mme.lng.del, Command.STOP, 4));
    }

    public void commandAction(Command command, Displayable displayable) {

        if (command.getCommandType() == Command.BACK) {
            switch (bkv) {
            case 0:
                plsm t = new plsm();

                mme.ShowIt(t);
                break;
            case 1:
                mme.ShowIt(mme.aupl);
                break;
            case 2:
                mme.pause();
                mme.ShowIt(mme.vdpl);
                break;
            case 3:
                mme.ShowIt(mme.mhtr);
                break;
            }

        } else if (command.getCommandType() == Command.STOP) {
            if (getSelectedIndex() > 0) {
                System.out.println("del");
                if ((mme.conf.cur_pll == getSelectedIndex() - 1) &&
                    (mme.conf.cur_state == type)) {
                    mme.conf.cur_state = 0;
                    mme.conf.cur_pll = 0;
                }
                mme.pllss.deletePLL(getSelectedIndex() - 1, type);

                pllsm t = new pllsm(type, type1, 0);
                mme.ShowIt(t);
            }
        } else {
            switch (getSelectedIndex()) {
            case 0:
                PllCreateForm t = new PllCreateForm(type, type1);
                mme.ShowIt(t);
                break;
            default:
                int id = getSelectedIndex() - 1;
                try {
                    mme.pllss.load(id, type);
                } catch (Exception ex) {

                }
                pll_editor tt = new pll_editor(id, type, type1, 0);
                mme.ShowIt(tt);
                break;
            }

        }
    }

}


class pll_editor extends List implements CommandListener {
    /**Construct the displayable*/
    public Image aud, vid, plss, bmk, dir, txt;
    int bkv = 0;
    private int pll, type, type1;
    private String[] pls;
    public pll_editor(int pl, int typ, int typ1, int bv) {
        super(mme.lng.pll, List.IMPLICIT);
        try {
            bkv = bv;
            pll = pl;
            type = typ;
            type1 = typ1;
            jbInit();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**Component initialization*/
    private void jbInit() throws Exception {
        // set up this Displayable to listen to command events
        //System.out.println("Creating PLE");




        pls = mme.pllss.getPlaylist(pll, type);
        try {
            pls = mme.pllss.getPlaylist(pll, type);
            try {
                aud = Image.createImage("/com/mh/mme/aud.png");
                vid = Image.createImage("/com/mh/mme/vid.png");
                plss = Image.createImage("/com/mh/mme/pll.png");
                bmk = Image.createImage("/com/mh/mme/bmk.png");
                txt = Image.createImage("/com/mh/mme/txt.png");

            } catch (Exception ex) {
                //System.out.println(ex);
            }

            //System.out.println(pls.length);
            if (pls.length > 0) {
                for (int i = 0; i < pls.length; i++) {
                    Image mime = null;

                    if ((pls[i].toLowerCase().endsWith(".3gp")) ||
                        (pls[i].toLowerCase().endsWith(".mp4"))) {
                        mime = vid;
                    }
                    if ((pls[i].toLowerCase().endsWith(".amr")) ||
                        (pls[i].toLowerCase().endsWith(".wav")) ||
                        (pls[i].toLowerCase().endsWith(".mp3")) ||
                        (pls[i].toLowerCase().endsWith(".imy")) ||
                        (pls[i].toLowerCase().endsWith(".mid")) ||
                        (pls[i].toLowerCase().endsWith(".midi")) ||
                        (pls[i].toLowerCase().endsWith(".bas")) ||
                        (pls[i].toLowerCase().endsWith(".mfi")) ||
                        (pls[i].toLowerCase().endsWith(".mmf"))) {
                        mime = aud;
                    }
                    if ((pls[i].toLowerCase().endsWith(".txt")) ||
                        (pls[i].toLowerCase().endsWith(".jad"))) {
                        mime = txt;
                    }

                    append(" " +
                           pls[i].substring(pls[i].
                                            lastIndexOf('/') + 1,
                                            pls[i].lastIndexOf('.')),
                           mime);
                }
            }

        } catch (Exception ex) {
            append("cannot list", null);
            //System.out.println("fld " + ex);
        } finally {
            //System.out.println("");
        }

        setCommandListener(this);
        addCommand(new Command(mme.lng.play, Command.SCREEN, 0));
        addCommand(new Command(mme.lng.del, Command.STOP, 2));
        addCommand(new Command(mme.lng.add, Command.HELP, 3));
        addCommand(new Command(mme.lng.back, Command.BACK, 1));
    }

    /**Handle command events*/
    public void commandAction(Command command, Displayable displayable) {
        if (command.getCommandType() == Command.HELP) {
            index t = new index(pll, type, type1);
            mme.ShowIt(t);
        } else if (command.getCommandType() == Command.BACK) {
            switch (bkv) {
            case 0:
                pllsm t = new pllsm(type, type1, 0);
                mme.ShowIt(t);
                break;
            case 1:
                mme.ShowIt(mme.aupl);
                break;
            case 2:
                mme.pause();
                mme.ShowIt(mme.vdpl);
                break;
            case 3:
                mme.ShowIt(mme.mhtr);
                break;
            }
        } else if (command.getCommandType() == Command.CANCEL) {

        } else if (command.getCommandType() == Command.SCREEN) {

            if (type == 6601) {
                mme.setMode(false);
                mme.conf.cur_pll = pll;
                mme.conf.cur_state = type;
                mme.conf.cur_cmp = getSelectedIndex();
                try {
                    mme.pllss.setCurPlaylist(pll, type);
                } catch (Exception ex) {

                }
                mme.pllss.setCurItem(getSelectedIndex());
                if (mme.pl != null) {
                    mme.pl.deallocate();
                    mme.pl.close();
                    mme.pl = null;
                }
                mme.setNoNext(false);
                mme.play(mme.pllss.getCurItem());
                mme.ShowIt(mme.aupl);
            } else if (type == 6602) {
                mme.setMode(true);
                mme.setVideo(0, 0, 132, 144, true, mme.vdpl);
                mme.conf.cur_pll = pll;
                mme.conf.cur_state = type;
                mme.conf.cur_cmp = getSelectedIndex();
                try {
                    mme.pllss.setCurPlaylist(pll, type);
                } catch (Exception ex) {

                }
                mme.pllss.setCurItem(getSelectedIndex());
                if (mme.pl != null) {
                    mme.pl.deallocate();
                    mme.pl.close();
                    mme.pl = null;
                }
                mme.setNoNext(false);
                mme.play(mme.pllss.getCurItem());
                mme.ShowIt(mme.vdpl);
            }
        } else if (command.getCommandType() == Command.STOP) {
            if (mme.pllss.getPlaylistLength(pll, type) - 1 >= 3) {
                mme.pllss.remove(getSelectedIndex(), pll, type);
                pll_editor t = new pll_editor(pll, type, type1, bkv);
                mme.ShowIt(t);
            } else {
                Alert al = new Alert(mme.lng.err,
                                     mme.lng.pnkt3, null,
                                     AlertType.ALARM);
                Displayable t = this;
                mme.ShowIt(al);
            }
        } else {

        }

    }

}


class PllCreateForm extends Form implements CommandListener {
    TextField pn;
    private int type, t1;
    public PllCreateForm(int typ, int t2) {
        super(mme.lng.create_new_pll);
        try {
            type = typ;
            t1 = t2;
            jbInit();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private void jbInit() throws Exception {
        pn = new TextField(mme.lng.ent_pll_name, "new_list", 50,
                           TextField.ANY);
        // Set up this Displayable to listen to command events
        append(pn);
        setCommandListener(this);
        // add the Exit command
        addCommand(new Command(mme.lng.ok, Command.OK, 1));
        addCommand(new Command(mme.lng.cancel, Command.CANCEL, 0));
    }

    public void commandAction(Command command, Displayable displayable) {
        if (command.getCommandType() == Command.OK) {
            int pll = mme.pllss.createPll(pn.getString(), type);
            index t = new index(pll, type, t1);
            mme.ShowIt(t);

        }
        if (command.getCommandType() == Command.CANCEL) {
            pllsm t = new pllsm(type, t1, 0);
            mme.ShowIt(t);
        }

    }

}


class index extends List implements CommandListener {
    public Image dir;
    private static int pll = 0;
    private static int[] ids = new int[100];
    private static int type, type1;
    boolean em;
    String[] cd = new String[8];
    public index() {
        super("", List.IMPLICIT);
        try {
            em = true;
            jbInit();
        } catch (Exception e) {
            e.printStackTrace();
        }

    }

    public index(int pl, int typ, int typ1) {
        super(mme.lng.files, List.IMPLICIT);
        try {
            em = false;
            type = typ;
            type1 = typ1;
            pll = pl;
            jbInit();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private void jbInit() throws Exception {
        cd = mfw.loadRoots();
        dir = Image.createImage("/com/mh/mme/dir.png");
        for (int i = 0; i < cd.length; i++) {
            append(cd[i], dir);

        }
        setCommandListener(this);

        if (!em) {
            addCommand(new Command(mme.lng.radd, Command.HELP, 2));
            addCommand(new Command(mme.lng.add, Command.ITEM, 3));
            addCommand(new Command(mme.lng.save, Command.EXIT, 4));
            addCommand(new Command(mme.lng.back, Command.BACK, 5));
        } else {
            addCommand(new Command(mme.lng.back, Command.EXIT, 4));
        }
    }

    public void commandAction(Command command, Displayable displayable) {

        if (command.getCommandType() == Command.EXIT) {
            System.out.println("exit");
            if (!em) {
                if (mme.pllss.getPlaylistLength(pll, type) >= 3) {
                    mme.pllss.save(pll, type);
                    pllsm t = new pllsm(type, type1, 0);
                    mme.ShowIt(t);
                } else {
                    Alert al = new Alert(mme.lng.err,
                                         mme.lng.pnkt3, null,
                                         AlertType.ALARM);
                    Displayable t = this;
                    mme.ShowIt(al);
                }
            } else {
                mm t = new mm(0);
                mme.ShowIt(t);
            }

        } else if (command.getCommandType() == Command.BACK) {
            if (!em) {
                if (mme.pllss.getPlaylistLength(pll, type) >= 3) {
                    mme.pllss.save(pll, type);
                    pllsm t = new pllsm(type, type1, 0);
                    mme.ShowIt(t);
                } else {
                    mme.pllss.deletePLL(pll, type);
                    mm t = new mm(0);
                    mme.ShowIt(t);
                }
            } else {
                mm t = new mm(0);
                mme.ShowIt(t);
            }
        } else if (command.getCommandType() == Command.HELP) {
            if (!em) {
                if ((getImage(getSelectedIndex()) == dir) &&
                    (getSelectedIndex() > 0)) {
                    mme.pllss.add(mfw.loadDiskDir(cd[getSelectedIndex()], true,
                                                  type1),
                                  pll, type);
                } else if (getSelectedIndex() > 0) {
                    mme.pllss.add(cd[getSelectedIndex()], pll, type);
                }
            }
        } else if (command.getCommandType() == Command.ITEM) {
            if (!em) {
                if ((getImage(getSelectedIndex()) == dir) &&
                    (getSelectedIndex() > 0)) {
                    mme.pllss.add(mfw.loadDiskDir(cd[getSelectedIndex()], false,
                                                  type1),
                                  pll, type);
                } else if (getSelectedIndex() > 0) {
                    mme.pllss.add(cd[getSelectedIndex()], pll, type);
                }
            }
        } else {

            if ((getImage(getSelectedIndex()) == dir)) {
                if (!em) {
                    index_dir nd = new index_dir(cd[getSelectedIndex()], pll,
                                                 type, type1);
                    mme.ShowIt(nd);
                } else {
                    index_dir nd = new index_dir(cd[getSelectedIndex()]);
                    mme.ShowIt(nd);
                }

            } else {
                mme.play(cd[getSelectedIndex()]);
            }
        }
    }

}


class index_dir extends List implements CommandListener {
    public Image aud, vid, pls, bmk, txt, dir;
    private static int pll = 0;
    private static int type, type1;
    boolean em;
    String[] cd;
    String curd;
    public index_dir(String cur) {
        super(mme.lng.files, List.IMPLICIT);
        try {

            curd = cur;
            em = true;
            jbInit();
        } catch (Exception e) {
            e.printStackTrace();
        }

    }

    public index_dir(String cur, int pl, int typ, int typ1) {
        super(mme.lng.files, List.IMPLICIT);
        try {

            curd = cur;
            em = false;
            type = typ;
            type1 = typ1;
            pll = pl;
            jbInit();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private void jbInit() throws Exception {

        append("..", dir);

        try {
            aud = Image.createImage("/com/mh/mme/aud.png");
            vid = Image.createImage("/com/mh/mme/vid.png");
            pls = Image.createImage("/com/mh/mme/pll.png");
            bmk = Image.createImage("/com/mh/mme/bmk.png");
            txt = Image.createImage("/com/mh/mme/txt.png");
            dir = Image.createImage("/com/mh/mme/dir.png");
        } catch (Exception ex) {
            System.out.println(ex);
        }

        cd = mfw.loadDiskDir(curd, false, mfw.ALL_ACSEPT);
        System.out.println("l=" + cd.length);
        if (cd.length > 0) {
            for (int i = 0; i < cd.length; i++) {
                //System.out.println("i = " + i);
                //System.out.println("cd [i] =" + cd[i]);
                Image mime = null;
                if (mfw.isDir(cd[i])) {
                    append(" " +
                           cd[i].substring(cd[i].substring(0,
                            cd[i].length() - 2).
                                           lastIndexOf('/') + 1,
                                           cd[i].length()),
                           dir);
                    continue;
                } else {
                    if ((cd[i].toLowerCase().endsWith(".3gp")) ||
                        (cd[i].toLowerCase().endsWith(".mp4"))) {
                        mime = vid;
                    }
                    if ((cd[i].toLowerCase().endsWith(".amr")) ||
                        (cd[i].toLowerCase().endsWith(".wav")) ||
                        (cd[i].toLowerCase().endsWith(".srt")) ||
                        (cd[i].toLowerCase().endsWith(".imy")) ||
                        (cd[i].toLowerCase().endsWith(".mid")) ||
                        (cd[i].toLowerCase().endsWith(".midi")) ||
                        (cd[i].toLowerCase().endsWith(".bas")) ||
                        (cd[i].toLowerCase().endsWith(".mfi"))) {
                        mime = aud;
                    }
                    if ((cd[i].toLowerCase().endsWith(".txt")) ||
                        (cd[i].toLowerCase().endsWith(".jad"))) {
                        mime = txt;
                    }
                    if ((cd[i].toLowerCase().endsWith(".apl")) ||
                        (cd[i].toLowerCase().endsWith(".vpl")) ||
                        (cd[i].toLowerCase().endsWith(".m3u"))) {
                        mime = pls;
                    }
                    if ((cd[i].toLowerCase().endsWith(".bmk"))) {
                        mime = bmk;
                    }
                    append(" " +
                           cd[i].substring(cd[i].lastIndexOf('/') + 1,
                                           cd[i].lastIndexOf('.')), mime);
                }
            }

        }
        setCommandListener(this);
        if (!em) {
            addCommand(new Command(mme.lng.radd, Command.HELP, 2));
            addCommand(new Command(mme.lng.add, Command.ITEM, 3));
            addCommand(new Command(mme.lng.save, Command.EXIT, 4));
            addCommand(new Command(mme.lng.back, Command.BACK, 5));
        } else {
            addCommand(new Command(mme.lng.back, Command.EXIT, 4));
        }
    }

    public void commandAction(Command command, Displayable displayable) {

        if (command.getCommandType() == Command.EXIT) {
            System.out.println("exit");
            if (!em) {
                if (mme.pllss.getPlaylistLength(pll, type) >= 3) {
                    mme.pllss.save(pll, type);
                    pllsm t = new pllsm(type, type1, 0);
                    mme.ShowIt(t);
                } else {
                    Alert al = new Alert(mme.lng.err,
                                         mme.lng.pnkt3, null,
                                         AlertType.ALARM);
                    Displayable t = this;
                    mme.ShowIt(al);
                }
            } else {
                mm t = new mm(0);
                mme.ShowIt(t);
            }

        } else if (command.getCommandType() == Command.HELP) {
            System.out.println("addrecr");
            if (!em) {
                if ((getImage(getSelectedIndex()) == dir) &&
                    (getSelectedIndex() > 0)) {
                    mme.pllss.add(mfw.loadDiskDir(cd[getSelectedIndex() -
                                                  1], true, type1),
                                  pll, type);
                } else if (getSelectedIndex() > 0) {
                    mme.pllss.add(cd[getSelectedIndex() - 1], pll, type);
                }
            }
        } else if (command.getCommandType() == Command.BACK) {
            if (!em) {
                if (mme.pllss.getPlaylistLength(pll, type) >= 3) {
                    mme.pllss.save(pll, type);
                    pllsm t = new pllsm(type, type1, 0);
                    mme.ShowIt(t);
                } else {
                    mme.pllss.deletePLL(pll, type);
                    mm t = new mm(0);
                    mme.ShowIt(t);
                }
            } else {
                mm t = new mm(0);
                mme.ShowIt(t);
            }
        } else if (command.getCommandType() == Command.ITEM) {
            System.out.println("add");
            if (!em) {
                if ((getImage(getSelectedIndex()) == dir) &&
                    (getSelectedIndex() > 0)) {
                    System.out.println("TP1 = " + type1);
                    mme.pllss.add(mfw.loadDiskDir(cd[getSelectedIndex() -
                                                  1], false, type1),
                                  pll, type);
                } else if (getSelectedIndex() > 0) {
                    mme.pllss.add(cd[getSelectedIndex() - 1], pll, type);
                }
            }
        } else {
            System.out.println("else");
            if ((getImage(getSelectedIndex()) == dir) &&
                (getSelectedIndex() > 0)) {
                System.out.println("dir");
                if (!em) {
                    index_dir nd = new index_dir(cd[getSelectedIndex() - 1],
                                                 pll, type, type1);
                    mme.ShowIt(nd);
                } else {
                    index_dir nd = new index_dir(cd[getSelectedIndex() - 1]);
                    mme.ShowIt(nd);
                }

            } else if ((getImage(getSelectedIndex()) == aud) &&
                       (getSelectedIndex() > 0)) {
                try {
                    mme.pllss.setCurPlaylist(cd[getSelectedIndex() - 1], 0);
                } catch (Exception ex1) {
                }
                mme.pllss.setCurItem(0);
                System.out.println("play");
                mme.setNoNext(true);
                mme.play(mme.pllss.getCurItem());
                mme.ShowIt(mme.aupl);
            } else if ((getImage(getSelectedIndex()) == vid) &&
                       (getSelectedIndex() > 0)) {
                mme.setNoNext(true);
                mme.setMode(true);
                mme.setVideo(0, 0, 132, 144, true, mme.vdpl);
                try {
                    mme.pllss.setCurPlaylist(cd[getSelectedIndex() - 1], 0);
                } catch (Exception ex1) {
                }
                mme.pllss.setCurItem(0);
                System.out.println("play");

                mme.play(mme.pllss.getCurItem());
                mme.ShowIt(mme.vdpl);
            } else if ((getImage(getSelectedIndex()) == pls) &&
                       (getSelectedIndex() > 0)) {
                System.out.println("play");
                try {
                    mme.pllss.loadFile(cd[getSelectedIndex() - 1]);
                } catch (Exception ex) {

                }

            } else if ((getImage(getSelectedIndex()) == txt) &&
                       (getSelectedIndex() > 0)) {

                if (mme.mhtr != null) {
                    mme.mhtr.saveBookmarkFile();
                    mme.conf.cur_book = cd[getSelectedIndex() - 1];
                    mme.mhtr = new mtr();
                } else {
                    mme.conf.cur_book = cd[getSelectedIndex() - 1];
                    mme.mhtr = new mtr();
                }
                try {
                    mme.mhtr.openBookmarkFile();
                } catch (Exception ex) {
                    System.out.println("can't open bookmark");
                }

                try {
                    mme.mhtr.openFile(mme.conf.cur_book,
                                      mme.conf.cur_blk * 1500,
                                      3000);
                } catch (Exception ex) {
                    System.out.println("can't open file");
                }
                int ll = 0;
                if (mme.mhtr.r90) {
                    ll = mme.mhtr.x.length;
                } else {
                    ll = mme.mhtr.x90.length;
                }
                mme.mhtr.recalcLines(ll);
                mme.ShowIt(mme.mhtr);

            } else if (!getString(getSelectedIndex()).equals(
                    "cannot open dir")) {
                System.out.println("up " + curd);
                String nd = curd.substring(0,
                                           curd.lastIndexOf('/',
                        curd.length() - 2)) + "/";
                System.out.println("ud = " + nd);
                if (nd.length() <= 3) {
                    index rt;
                    if (!em) {
                        rt = new index(pll, type, type1);

                    } else {
                        rt = new index();

                    }
                    mme.ShowIt(rt);
                } else {
                    index_dir rt;
                    if (!em) {
                        rt = new index_dir(nd, pll, type, type1);

                    } else {
                        rt = new index_dir(nd);

                    }
                    mme.ShowIt(rt);

                }
            }
        }
    }
}


class opt extends Form implements CommandListener {
    ChoiceGroup cg1;
    ChoiceGroup cg_skin;
    ChoiceGroup cg_font;
    ChoiceGroup cg_lng;
    String[] t1;
    String[] t2;
    String[] t3;
    int bkv;
    public opt(int bv) {
        super(mme.lng.opt);
        try {
            bkv = bv;
            jbInit();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private void jbInit() throws Exception {
        cg1 = new ChoiceGroup(mme.lng.loadvar, ChoiceGroup.POPUP);
        cg_skin = new ChoiceGroup(mme.lng.skin, ChoiceGroup.EXCLUSIVE);
        cg_font = new ChoiceGroup(mme.lng.font, ChoiceGroup.EXCLUSIVE);
        cg_lng = new ChoiceGroup(mme.lng.lng, ChoiceGroup.EXCLUSIVE);

        cg1.append(mme.lng.lstate, null);
        cg1.append(mme.lng.mm, null);
        cg1.append(mme.lng.aud, null);
        cg1.append(mme.lng.vid, null);
        cg_skin.append(mme.lng.nc, null);
        cg_skin.append(mme.lng.std, null);
        try {

            t1 = mfw.loadDiskDir("0:/Misc/MME/Skins", false,
                                 mfw.SKIN_FORMATS);

        } catch (Exception ex) {
            //System.out.println("SKIN LOAD FLD");
        }
        try {
            for (int i = 0; i < t1.length; i++) {
                cg_skin.append(t1[i].substring(t1[i].lastIndexOf('/') + 1,
                                               t1[i].lastIndexOf('.')), null);
            }
        } catch (Exception ex) {

        }
        cg_font.append(mme.lng.nc, null);
        cg_font.append(mme.lng.std, null);
        try {
            t2 = mfw.loadDiskDir("0:/Misc/MME/Fonts", false,
                                 mfw.FONT_FORMATS);

        } catch (Exception ex) {
            //System.out.println("SKIN LOAD FLD");
        }
        try {
            for (int i = 0; i < t2.length; i++) {
                cg_font.append(t2[i].substring(t2[i].lastIndexOf('/') + 1,
                                               t2[i].lastIndexOf('.')), null);
            }
        } catch (Exception ex) {

        }
        cg_lng.append(mme.lng.nc, null);
        cg_lng.append("", null);
        try {
            t3 = mfw.loadDiskDir("0:/Misc/MME/LangPacks", false,
                                 mfw.LNG_FORMATS);
        } catch (Exception ex) {
            System.out.println("LNG LOAD FLD " + ex);
        }
        try {
            for (int i = 0; i < t3.length; i++) {
                cg_lng.append(t3[i].substring(t3[i].lastIndexOf('/') + 1,
                                              t3[i].lastIndexOf('.')), null);
            }
        } catch (Exception ex) {

        }

        append(cg1);
        append(cg_skin);
        if (mme.mhtr != null) {
            append(cg_font);
        }
        append(cg_lng);
        setCommandListener(this);
        addCommand(new Command(mme.lng.ok, Command.OK, 0));
        addCommand(new Command(mme.lng.cancel, Command.BACK, 1));
    }

    public void commandAction(Command command, Displayable displayable) {
        if (command.getCommandType() == Command.OK) {
            mme.conf.ss = cg1.getSelectedIndex();
            if (cg_skin.getSelectedIndex() == 1) {
                mme.skin.openSkinFile("null.null");
            } else if (cg_skin.getSelectedIndex() > 1) {
                mme.skin.openSkinFile(t1[cg_skin.getSelectedIndex() - 2]);
            }
            if (cg_font.getSelectedIndex() == 1) {
                mme.mhtr.recalcFCS("null.null");
            } else if (cg_font.getSelectedIndex() > 1) {
                mme.mhtr.recalcFCS(t2[cg_font.getSelectedIndex() - 2]);
            }
            if (cg_lng.getSelectedIndex() == 1) {
                mme.lng.openLngFile("null.null");
            } else if (cg_lng.getSelectedIndex() > 1) {
                mme.lng.openLngFile(t3[cg_lng.getSelectedIndex() - 2]);
            }

            mm t = new mm(bkv);
            mme.ShowIt(t);

        } else {
            mm t = new mm(bkv);
            mme.ShowIt(t);
        }
    }

}
