package com.mh;

import java.util.Random;
import java.io.*;


/**
 * <p>Title: Mh Media Envirnoment</p>
 *
 * <p>Description: New Mh Media Product</p>
 *
 * <p>Copyright: Mh Copyright (c) 2005-2007</p>
 *
 * <p>Company: Mh Xorp <WAS></p>
 *
 * @author Mihard
 * @version null
 */
public class playliststore {
    public static final int ALL_TYPE = 660, AUDIO_TYPE = 6601,
            VIDEO_TYPE = 6602,
                         LIB_TYPE = 6603;
    public static int t = 6601, cur = -1;
    public static int[] prev = new int[0];
    private static String[][][] plls = null;
    private static String[][] pllsn = null;
    private static String[] cur_list = null;

    public playliststore() {
        String[] t = null;
        plls = new String[2][0][0];
        pllsn = new String[2][0];
        try {

            t = mfw.loadPLLS(6601);
            plls[0] = new String[t.length][0];
            pllsn[0] = t;

        } catch (Exception ex) {

            pllsn[0] = new String[0];
            plls[0] = new String[0][0];
            System.out.println(ex);
        }
        try {
            t = mfw.loadPLLS(6602);
            plls[1] = new String[t.length][0];
            pllsn[1] = t;

        } catch (Exception ex) {
            pllsn[1] = new String[0];
            plls[1] = new String[0][0];
        }

    }

    public static String[] getPlaylists(int type) {
        String[] ret = pllsn[type - 6601];
        for (int i = 0; i < pllsn[type - 6601].length; i++) {
            System.out.println("1 pllsn[type-6601] " + i + " = " + pllsn[type -
                               6601][i]);
        }
        if (ret == null) {
            ret = new String[0];
        }
        return ret;
    }

    public static String[] getPlaylist(int num, int type) {
        String[] ret = new String[0];
        try {
            ret = plls[type - 6601][num];
        } catch (Exception ex) {
        }
        return ret;
    }

    public static int getPlaylistLength(int num, int type) {
        int ret = 0;
        try {
            ret = plls[type - 6601][num].length;
        } catch (Exception ex) {
        }
        return ret;
    }

    public static String getCurItem() {

        if ((cur_list != null) && (cur >= 0)) {
            try {
                return cur_list[cur];
            } catch (Exception ex) {
                return "";
            }

        } else {

            return "";
        }
    }

    public static String getItem(int n, int t1, int t0) {
        try {
            return plls[t0 - 6601][t1][n];
        } catch (Exception ex) {
            return "";
        }

    }


    public static void setCurItem(int in) {

        cur = in;
        addPrev(cur);
    }

    public static void setCurPlaylist(int num, int type) throws Exception {

        if (!loaded(num, type)) {
            System.out.println("was neeb load!");
            load(num, type);
        }
        cur_list = plls[type - 6601][num];
        prev_recalc();
    }

    public static void setCurPlaylist(String fn, int type) throws Exception {
        cur_list = new String[4];
        cur_list[0]=fn;        cur_list[1]=fn;        cur_list[2]=fn;        cur_list[3]=fn;
        prev_recalc();
    }


    public static int createPll(String name, int type) {
        int nm = 1;
        String new_name = name;
        int ret = 0;
        String[] temp = null;
        String[][] tp = null;
        temp = pllsn[type - 6601];
        tp = plls[type - 6601];
        pllsn[type - 6601] = new String[temp.length + 1];
        plls[type - 6601] = new String[temp.length + 1][0];

        for (int a = 0; a < temp.length; a++) {
            pllsn[type - 6601][a] = temp[a];
            if (tp[a] == null) {
                plls[type - 6601][a] = new String[0];
            } else {
                plls[type - 6601][a] = tp[a];
            }
        }
        boolean flag = false;
        for (int i = 0; i < pllsn[type - 6601].length; i++) {
            if (new_name.equals(pllsn[type - 6601][i])) {
                flag = true;
                break;
            }
        }
        int iter = 0;
        while (flag) {
            iter++;
            new_name = name + "_" + iter;
            flag = false;
            for (int i = 0; i < pllsn[type - 6601].length; i++) {
                if (new_name.equals(pllsn[type - 6601][i])) {
                    flag = true;
                    break;
                }
            }
        }

        pllsn[type - 6601][pllsn[type - 6601].length - 1] = new_name;
        ret = pllsn[type - 6601].length - 1;
        System.out.println("ret=" + ret);
        try {
            mfw.savePLLS(type, pllsn[type - 6601]);
            //mfw.savePLL(type, ret, plls[type - 6601][ret]);
        } catch (Exception ex1) {
            System.out.println("creation ex " + ex1);
        }
        return ret;

    }

    public static void deletePLL(int num, int type) {
        try {
            mfw.delPLL(type, pllsn[type-6601][num]);
            String[][] temp = plls[type - 6601];
            String[] tempn = pllsn[type - 6601];
            plls[type - 6601] = new String[temp.length - 1][0];
            pllsn[type - 6601] = new String[tempn.length - 1];
            int ai = 0;
            for (int a = 0; a < temp.length; a++) {
                if (a != num) {
                    plls[type - 6601][ai] = temp[a];
                    pllsn[type - 6601][ai] = tempn[a];
                    ai++;

                }
            }

            try {
                mfw.savePLLS(type, pllsn[type - 6601]);
            } catch (Exception ex1) {
            }

        } catch (Exception ex) {
            System.out.println(ex);
        }

    }

    private static void prev_recalc() {
        if (cur_list.length > 2) {
            prev = new int[(cur_list.length / 3) * 2];
        } else {
            prev = new int[0];
        }
        for (int i = 0; i < prev.length; i++) {
            prev[i] = -1;
        }

    }

    public static boolean loaded(int num, int type) {
        if ((plls[type - 6601][num] == null) ||
            (plls[type - 6601][num].length <= 0)) {
            return false;
        } else {
            return true;

        }
    }

    public static void loadFile(String name) throws Exception {
        if (name.toLowerCase().endsWith(".m3u")) {
            byte[] bf = new byte[0];
            String[] strr = new String[0],strrp=new String[0];

            try {
                bf = mfw.openDataFile(name);
                System.out.println("FR ENDE");
                System.out.println("FA BEGIN");
                int lns = 1, iln = 0;
                for (int i = 0; i < bf.length; i++) {
                    if (13 == ((int) bf[i])) {
                        System.out.println(i + " " + ((int) bf[i]));
                        lns++;
                    }
                }
                System.out.println("lns = " + lns);
                String str = new String(bf);
                bf = null;
                if (lns > 1) {
                    strr = new String[lns];
                    strrp = new String[lns];
                    int last = 0;
                    for (int i = 0; i < str.getBytes().length; i++) {
                        if ((int) str.getBytes()[i] == 13) {
                            if (iln > 0) {
                                strr[iln] = str.substring(last + 2, i);
                            } else {
                                strr[iln] = str.substring(last, i);
                            }
                            System.out.println("iln = " + iln + " strr[iln]=" +
                                               strr[iln]);
                            iln++;
                            last = i;
                        }
                    }
                    strr[lns - 1] = str.substring(last + 2, str.length());
                    System.out.println("iln = " + (lns - 1) + " strr[iln]=" +
                                       strr[lns - 1]);

                }
                int acl = 0;
                for (int i = 0; i < strr.length; i++) {

                    strr[i] = strr[i].replace('\\', '/');
                    if (((strr[i].indexOf("#") < 0)||(strr[i].indexOf("#") > 7)) && (strr[i].length() > 0)) {
                        if (strr[i].indexOf("#") > 7) {
                            strrp[acl] = strr[i].substring(0,strr[i].indexOf("#"));
                        }
                        strrp[acl] = strr[i];
                        System.out.println("acl = " + acl + " strr[acl]=" +
                                           strrp[acl]);
                        acl++;
                    }
                }
                System.out.println(acl);
                strr = new String[acl];
                for (int i = 0; i < acl; i++) {
                    strr[i] = strrp[i];
                    System.out.println(i + " " + strr[i]);
                }
                strrp = null;
                str=null;
            } catch (Exception ex) {
                ex.printStackTrace();
            } finally {
                System.out.println("FA DONE");
                if (strr.length >= 3) {
                    int n = createPll(name.substring(0, name.lastIndexOf('.')),
                                      6601);
                    plls[0][n] = strr;
                }

            }
        }

        else if (name.toLowerCase().endsWith(".apl")) {
            String[] tmp = null;
            try {
                tmp = mfw.openUTFFile(name);
            } catch (Exception ex) {
                System.out.println("apl loading");
                ex.printStackTrace();
            } finally {
                if (tmp.length >= 3) {
                    int n = createPll(name.substring(0, name.lastIndexOf('.')),
                                      6601);
                    plls[0][n] = tmp;
                }
            }
        } else if (name.toLowerCase().endsWith(".vpl")) {
            String[] tmp = null;
            try {
                tmp = mfw.openUTFFile(name);
            } catch (Exception ex) {
                System.out.println("apl loading");
                ex.printStackTrace();
            } finally {
                if (tmp.length >= 3) {
                    int n = createPll(name.substring(1, name.lastIndexOf('.')),
                                      6602);
                    plls[1][n] = tmp;
                }
            }

        }

    }

    public static void saveFile(int num, int type,String name) {
        String rsc = "._pl";
        if (type-6601==0) {
            rsc=".apl";
        } else {rsc=".vpl";}
        try {
            mfw.saveUTFFile("0:/Misc/MME/Playlists/"+pllsn[type - 6601][num] + rsc,
                            plls[type - 6601][num]);
        } catch (IOException ex) {
            System.out.println("pll save "+ex);
        }
    }




    public static void load(int num, int type) throws Exception{
        if (!loaded(num, type)) {
            try {
                System.out.println("type = " + (type) + "| num = " + (num + 1));
                plls[type -
                        6601][num] = mfw.loadPLL(type, pllsn[type-6601][num]);
            } catch (Exception ex) {
                throw new Exception("PLL Loading error");
            }
        }
    }

    public static void save(int num, int type) {
        try {
            mfw.savePLL(type, pllsn[type-6601][num], plls[type - 6601][num]);
        } catch (Exception ex) {
        }
    }

    public static void add(String file, int num, int type) {
        System.out.println("file = " + file);
        if (plls[type - 6601][num] == null) {
            System.out.println("null variant");
            plls[type - 6601][num] = new String[1];
            plls[type - 6601][num][0] = file;
            System.out.println("files[0] = " + plls[type - 6601][num][0]);
        } else {
            System.out.println("not null variant");
            String[] temp = plls[type - 6601][num];
            plls[type - 6601][num] = new String[temp.length + 1];
            for (int a = 0; a < temp.length; a++) {
                plls[type - 6601][num][a] = temp[a];
            }
            plls[type - 6601][num][plls[type - 6601][num].length -
                    1] = file;
            for (int i = 0; i < plls[type - 6601][num].length; i++) {
                System.out.println("files " + i + " = " + plls[type -
                                   6601][num][i]);
            }
        }
        prev_recalc();
    }

    public static void add(String[] list, int num, int type) {
        if (plls[type - 6601][num] == null) {
            int nl = list.length;
            plls[type - 6601][num] = new String[nl];
            int ai = 0;
            for (int a = 0; a < list.length; a++) {
                plls[type - 6601][num][ai] = list[a];
                ai++;
            }
        } else {
            int ai = 0;
            int nl = list.length + plls[type - 6601][num].length;
            String[] temp = plls[type - 6601][num];
            plls[type - 6601][num] = new String[nl];
            for (int a = 0; a < temp.length; a++) {
                plls[type - 6601][num][ai] = temp[a];
                ai++;
            }
            for (int a = 0; a < list.length; a++) {
                plls[type - 6601][num][ai] = list[a];
                ai++;
            }
        }
        prev_recalc();
    }

    public static void remove(int inum, int num, int type) {
        if (plls[type - 6601][num] == null) {
        } else {
            String[] temp = plls[type - 6601][num];
            plls[type - 6601][num] = new String[temp.length - 1];
            int ai = 0;
            for (int a = 0; a < temp.length; a++) {
                if (a != inum) {
                    plls[type - 6601][num][ai] = temp[a];
                    ai++;
                }
            }

        }
        save(num, type);

    }

    public static void swp(int num1, int num2, int num, int type) {
        String tmp = plls[type - 6601][num][num2];
        plls[type - 6601][num][num2] = plls[type - 6601][num][num1];
        plls[type - 6601][num][num1] = tmp;
    }

    public static void addPrev(int num) {
        for (int v = 0; v < prev.length - 1; v++) {
            prev[v] = prev[v + 1];
        }
        prev[prev.length - 1] = num;
    }

    public static String getNext(boolean srf) {
        int i = cur, pls = cur_list.length;
        String o;
        if (srf) {
            boolean f1 = true;
            Random r = new Random();
            while (f1) {
                if (pls <= 0) {
                    i = 2;
                } else {
                    i = r.nextInt(pls + 4);
                }
                System.out.println("i=" + i);
                f1 = false;
                i = i - 2;
                System.out.println(" i=" + i);
                for (int j = 1; j < prev.length; j++) {
                    if ((i == prev[j]) || (i < 0) || (i >= pls)) {
                        System.out.println("yes");
                        f1 = true;
                        break;
                    }
                }
                System.out.println("  i=" + i);
            }

        } else {

            if (i < pls - 1) {
                i++;
            } else {
                i = 0;
            }

        }
        cur = i;
        try {
            o = cur_list[i];
            addPrev(cur);
        } catch (Exception ex) {
            o = "";
            addPrev( -1);
        }
        return o;

    }

    public static String getPrev() {

        String i = cur_list[prev[prev.length - 1]];
        int t = prev[prev.length - 1];
        for (int d = prev.length - 1; d > 0; d--) {
            prev[d] = prev[d - 1];
        }
        prev[0] = t;
        cur = t;
        return i;
    }

}
